/*
Программа управления промежуточным контроллером и резерным едром много домаю
*/
#include <ShiftRegLCD123.h>     //LCD library
//#include <EEPROM.h>
#include <dht.h>


#define DHT22_PIN 9
#define ver "0.1 alpha"

dht DHT;

const int rounds = 100;
const byte dataPin  = 12;    // SR Data from Arduino pin 10
const byte clockPin = 13;    // SR Clock from Arduino pin 11
const byte enablePin = 11;   // LCD enable from Arduino pin 12


const byte LED = 6;
const byte NEXT = 4;                   // NEXT button
const byte POWER = 2;                   // POWER button
const byte STOP = 5;                   // STOP button
const byte PLAY = 8;                    // PLAY button
const byte PREV = 7;                    // PREV button
const byte POWER_pin = 3;                   // Power control pin

long Vcc2, temp2, volt2;
int power_mode=1, i=0, r2=0,y=0;
double charge=0;
double humidity, temperature2, humidity2, temperature22;
float Vcc, Vccr, volt, temp;

ShiftRegLCD123 srlcd(dataPin, clockPin, enablePin, SRLCD123);

void setup(){
  pinMode(POWER_pin, OUTPUT);
  pinMode(NEXT, INPUT);
  pinMode(PREV, INPUT);
  pinMode(POWER, INPUT);
  pinMode(STOP, INPUT);
  pinMode(PLAY, INPUT);
  pinMode(LED, OUTPUT);
  //attachInterrupt(0, power, RISING);
  analogWrite(LED, 255);
  
  srlcd.begin (20,4,0,1);                                // init LCD interface
  srlcd.backlightOn();
  srlcd.home();   
  digitalWrite(POWER_pin, HIGH);
  srlcd.print("КУИП V");
  srlcd.print(ver);
  srlcd.setCursor (0,1);                      // cursor to beginning of LCD 2nd. line
  srlcd.print("Загрузка.");
  
  Serial.begin(9600);
  delay(1000);
  srlcd.clear();
}

void loop() {  
  Vccr = readVcc()-75.0;
  Vcc2 = Vccr + Vcc2;
  volt2 = analogRead(0) + volt2;
  if(digitalRead(2) == HIGH)
  {
   power();
   while(digitalRead(2) == HIGH)
     delay(1000); 
  }

  if(i>=rounds)
  {
    
   DHT.read22(DHT22_PIN);
   humidity=humidity+DHT.humidity;
   temperature2=temperature2+DHT.temperature;
   y++;
    Vcc=Vcc2/i;
    Vcc = Vcc / 1000.0;
    volt=volt2/i;
    volt=((volt / 1023.0) * Vcc * 3.0340);
    charge=GetCharge(volt);
    srlcd.setCursor(19,0);
    if(charge <= 100 && charge > 80)
     srlcd.write(0x0B);
    if(charge <= 80 && charge > 60)
     srlcd.write(0x0C);
    if(charge <= 60 && charge > 40)
     srlcd.write(0x0D);
    if(charge <= 40 && charge > 20)
     srlcd.write(0x0E);
    if(charge <= 20 && charge >= 5)
     srlcd.write(0x0F);
    Vcc2=0;
    volt2=0;
    i=0;
    if(power_mode > 0)
    {
     r2++;
     if(r2 > 200)
     {
      power();
      r2=0;
     }
    }
  }
  if(y==20)
  {
    humidity2=humidity/y;
    temperature22=temperature2/y;
    humidity=0;
    temperature2=0;
    y=0;
  }
  i++;
  if(i==(rounds/2)){
    srlcd.setCursor(0, 0);
    srlcd.print("IV:");
    srlcd.print(Vcc);
    srlcd.setCursor(0,1);
    srlcd.print("AV:");
    srlcd.print(volt);
    srlcd.print(" BAT:");
    srlcd.print(charge);
 
    srlcd.setCursor(0,3);
    srlcd.print("\u0422:");
    srlcd.print(temperature22);
    srlcd.print("C \u0412:");
    srlcd.print(humidity2);
    srlcd.print("%   ");
    
    Serial.print("vcc:");
    Serial.print( Vcc );
    Serial.print(" Bat:");
    Serial.print(charge);
    Serial.print(" ai:");
    Serial.print(volt);
    Serial.print(" Hum:");
    Serial.print(humidity2,4);
    Serial.print(" OT:");
    Serial.print(temperature22,4);
    Serial.println(" ;");
  }
  delay(2);
}


void power()
{
 if(power_mode == 0)
 {
  //digitalWrite(POWER_pin, HIGH);
  srlcd.backlightOn();
  //srlcd.home();   
  analogWrite(LED, 255);
  
  //srlcd.print("КУИП V");
  //srlcd.print(ver);
  //srlcd.setCursor (0,1);                      // cursor to beginning of LCD 2nd. line
  //srlcd.print("Загрузка.");
  power_mode=1; 
  delay(1000);
  srlcd.clear();
  //i=rounds+10;
  return;
 } 
 if(power_mode >= 1)
 {
  power_mode=0;
  srlcd.backlightOff();
  analogWrite(LED, 10);
  delay(1000);
  //digitalWrite(POWER_pin, LOW);
  return;
 }
}

long readVcc() {
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
  #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
    ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
     ADMUX = _BV(MUX5) | _BV(MUX0) ;
  #else
    ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #endif  
 
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA,ADSC)); // measuring
 
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH  
  uint8_t high = ADCH; // unlocks both
 
  long result = (high<<8) | low;
 
  result = 1125300L / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000
  return result; // Vcc in millivolts
}

double GetCharge(double voltage)
{double charge=0;
  if(voltage > 13.2 )
    return 101;
  if(voltage > 11.9)
  {
    voltage = voltage - 11.9;
    charge = (voltage / 1.2) * 100; 
  }
  return charge;
}


long readTemp() {
  long result;
  // Read temperature sensor against 1.1V reference
  ADMUX = _BV(REFS1) | _BV(REFS0) | _BV(MUX3);
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA,ADSC));
  result = ADCL;
  result |= ADCH<<8;
  result = (result - 125) * 1075;
  return result;
}
